# -*- coding: utf-8 -*-
#!/usr/bin/python

# 必要なライブラリのインポート
import pyaudio
import sys
import os
import smbus
import math
import time

# 色の定義
BLACK = (  0,   0,   0)
WHITE = (255, 255, 255)
RED   = (255,   0,   0)
GREEN = (  0, 255,   0)
YELLOW = (255, 255,   0)
BLUE  = (  0,  0, 255)
BACK=(0,100,0)

ADDRESS = 0x2A #S11059 device address
CHANNEL = 1
CTLREG = 0x00
OUTREG = 0x03
RESET = 0x83
RESTART = 0x03

CARD = 1 #OUTPUTの指定
DEVICE = 0 #OUTPUTの指定

def talk(message="こんにちは", card=1, device=0):    	
    os.system('/home/pi/aquestalkpi/AquesTalkPi " ' + message + ' " | aplay -Dhw:1,0') 

class S11059:
    def __init__(self, bus, addr):
        self.bus = smbus.SMBus(bus)
        self.addr = addr

    def writebyte(self, cmd, data):
        self.bus.write_byte_data(self.addr, cmd, data)

    def readblock(self, cmd, len):
        return self.bus.read_i2c_block_data(self.addr, cmd, len)

if __name__ == '__main__':

    dev = S11059(CHANNEL, ADDRESS)

     #初期化
    dev.writebyte(CTLREG,RESET)
    dev.writebyte(CTLREG,RESTART)

    time.sleep(2.5)

    dev.writebyte(OUTREG,CTLREG)
    KR=1
    KG=1.1
    KB=1.6
    
    K1=1.5
       
# 無限ループ
    while True:
        #データ取得
        read_data = dev.readblock(CTLREG, 11)

        #データ設定
        red = read_data[3] << 8 | read_data[4]
        green = read_data[5] << 8 | read_data[6]
        blue = read_data[7] << 8 | read_data[8]

        red=KR*red
        green=KG*green
        blue=KB*blue

        talk_message="こんにちは"
        
        
        if red>K1*blue and green>K1*blue :
            ncolor="YELLOW"
            rcolor=YELLOW
            talk_message="黄色です"
        elif red>green and red>blue :
            ncolor="RED"
            rcolor=RED
            talk_message="赤です"
        elif blue>red and blue>green :
            ncolor="BLUE"
            rcolor=BLUE
            talk_message="青です"
        elif green>red and green > blue:
            ncolor="GREEN"
            rcolor=GREEN
            talk_message="緑です"

        print "(R, G, B)=(%d , %d , %d) color=%s" % (red,green,blue,ncolor)
        talk(talk_message, CARD, DEVICE)
        time.sleep (4)
        
        

    
